//
//  REString.m
//
//  Created by Jerome Paschoud on 18.11.06.
//  Based on the code of David Teare 
//  http://tearesolutions.com/2006/09/how_to_use_regular_expressions_1.html
//  Updated on 16.05.07.
//  Updated on 08.04.09: correct the beavior with Unicode characters
//                       correction provided by Ian Atha
//	Source available at http://www.spikesoft.ch
//  Copyright 2006-2007 SpikeSoft. All rights reserved.
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#import <regex.h>
#import "REString.h"
//#define DEBUG


@implementation NSString(AWSRegex)

- (BOOL)matches:(NSString *) regex withSubstring:(NSMutableArray *) substring{
	BOOL result = NO;
    regex_t re;
    if (0 == regcomp(&re, [regex UTF8String], REG_EXTENDED)) {
		size_t nmatch = re.re_nsub +1;
		regmatch_t pmatch[nmatch]; 
		if (0 == regexec(&re, [self UTF8String], nmatch, pmatch, 0)) {
			result = YES;
			if (substring  != nil){
				int i = 1;
				for (i; i < nmatch; i++){
					if (pmatch[i].rm_so == pmatch[i].rm_eo & pmatch[i].rm_so == -1) {
						// there is no matching charaters for this partial expression
						[substring addObject:@""];
						#ifdef DEBUG
						NSLog(@"-1,-1, ");
						#endif
					}
					else {
						size_t length = pmatch[i].rm_eo - pmatch[i].rm_so;
						char _matching[length + 1];
						strncpy(_matching, [self UTF8String] + pmatch[i].rm_so, length);
						_matching[length] = '\0';
						NSString* matching = [NSString stringWithUTF8String:_matching];
						[substring addObject:matching];
						#ifdef DEBUG
							NSLog(@"%qd,%qd, %@",pmatch[i].rm_so,pmatch[i].rm_eo,matching);
						#endif
					}
				}
			}
		}
    }
    regfree(&re);
    return result;
}
  
@end
