//
//  REString.m
//
//  Created by Jerome Paschoud on 16.05.07.
//  Updated on 08.04.09: modify the example to use unicode char
//	Source available at http://www.spikesoft.ch
//  Copyright 2007 SpikeSoft. All rights reserved.
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//  The purpose of this small script is to demonstrate how to use
//  the matches methods provides by the REString class.
//
//  output is:
//
//  2007-06-16 20:02:57.883 test[2971] [0] = 12
//  2007-06-16 20:02:57.884 test[2971] [1] = 
//  2007-06-16 20:02:57.884 test[2971] [2] = 12



#import <Foundation/Foundation.h>
#import "REString.h"

int main (int argc, const char * argv[]) {

    int i;
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
	NSMutableArray *myArray  = [[NSMutableArray alloc] init];
	NSString       *myString = @"12";
	
	[myString matches: @"(()?([0-9]{2}))" withSubstring: myArray];
	for (i = 0; i < [myArray count]; i++) {
		NSLog(@"[%i] = %@", i, [myArray objectAtIndex:i]);
	}
	
	[myArray release];
	myArray = nil;
    [pool release];
	pool = nil;
    return 0;
}
